#
# EFFECTS
#
effect give @a[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] minecraft:resistance 2 200 true
effect give @a minecraft:saturation 50000 5 true
effect give @e[tag=inv_mob] minecraft:invisibility 3 3 true
effect give @e[tag=inv_mob] minecraft:resistance 3 250 true
effect give @e[tag=inv_mob] minecraft:regeneration 3 250 true

# AntiDropItem
execute as @e[type=item] at @s run data merge entity @s {PickupDelay:0}

# Coins Booster Type
scoreboard players set @a[tag=coins_x2_boost] booster_type 2
scoreboard players set @a[tag=coins_x3_boost] booster_type 3

execute as @a at @s run fill ~6 ~6 ~6 ~-6 ~-3 ~-6 air replace minecraft:command_block{Command:"summon creeper ~ ~1 ~ {Fuse:-1,ExplosionRadius:2b}",auto:1b,SuccessCount:1}

# Creators Things

execute if block 13 14 0 minecraft:spruce_button[powered=true] run tellraw @a "§r<§chapyl§r> Buy redstone lessons for only 50.99 CatCoins!"
execute if block 13 14 0 minecraft:spruce_button[powered=true] run setblock 13 14 0 minecraft:spruce_button[powered=false,facing=west]

execute if block 12 14 -4 minecraft:spruce_button[powered=true] run tellraw @a "§r<§7Dirty§6El§r> Lie →"
execute if block 12 14 -4 minecraft:spruce_button[powered=true] run setblock 12 14 -4 minecraft:spruce_button[powered=false,facing=west]

execute if block 12 14 4 minecraft:spruce_button[powered=true] run tellraw @a "§r<§9sdimas74§r> Meow!"
execute if block 12 14 4 minecraft:spruce_button[powered=true] run setblock 12 14 4 minecraft:spruce_button[powered=false,facing=west]

# SHIFT LOBBY DETECTION
scoreboard players set @a[scores={lobby_shift=1..}] lobby_S 1
scoreboard players set @a[scores={lobby_shift=..0}] lobby_S 0
scoreboard players set @a[scores={lobby_shift=1..}] lobby_shift 0

kill @e[type=tnt]

# MAPS ACTIONBAR
#
### PIT
execute as @a unless entity @s[scores={shop=1..}] if score map map matches 1 run title @s[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] actionbar ["",{"text":"Chosen Map:","color":"yellow"},{"text":" "},{"text":"THE PIT","color":"red"},{"text":" "},{"text":"|","color":"white"},{"text":" "},{"text":"Boosters Left:","color":"yellow"},{"text":" "},{"score":{"name":"*","objective":"boosts_game"},"color":"dark_green"},{"text":" \u00A77(x"},{"score":{"name":"*","objective":"booster_type"},"color":"gray"},{"text":"\u00A77)"}]

### RAILWAY STATION
execute as @a unless entity @s[scores={shop=1..}] if score map map matches 2 run title @s[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] actionbar ["",{"text":"Chosen Map:","color":"yellow"},{"text":" "},{"text":"RAILWAY STATION","color":"red"},{"text":" "},{"text":"|","color":"white"},{"text":" "},{"text":"Boosters Left:","color":"yellow"},{"text":" "},{"score":{"name":"*","objective":"boosts_game"},"color":"dark_green"},{"text":" \u00A77(x"},{"score":{"name":"*","objective":"booster_type"},"color":"gray"},{"text":"\u00A77)"}]

### THE NETHER
execute as @a unless entity @s[scores={shop=1..}] if score map map matches 3 run title @s[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] actionbar ["",{"text":"Chosen Map:","color":"yellow"},{"text":" "},{"text":"THE NETHER","color":"red"},{"text":" "},{"text":"|","color":"white"},{"text":" "},{"text":"Boosters Left:","color":"yellow"},{"text":" "},{"score":{"name":"*","objective":"boosts_game"},"color":"dark_green"},{"text":" \u00A77(x"},{"score":{"name":"*","objective":"booster_type"},"color":"gray"},{"text":"\u00A77)"}]

### GREENHOUSE
execute as @a unless entity @s[scores={shop=1..}] if score map map matches 4 run title @s[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] actionbar ["",{"text":"Chosen Map:","color":"yellow"},{"text":" "},{"text":"GREENHOUSE","color":"red"},{"text":" "},{"text":"|","color":"white"},{"text":" "},{"text":"Boosters Left:","color":"yellow"},{"text":" "},{"score":{"name":"*","objective":"boosts_game"},"color":"dark_green"},{"text":" \u00A77(x"},{"score":{"name":"*","objective":"booster_type"},"color":"gray"},{"text":"\u00A77)"}]

### SKY
execute as @a unless entity @s[scores={shop=1..}] if score map map matches 5 run title @s[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] actionbar ["",{"text":"Chosen Map:","color":"yellow"},{"text":" "},{"text":"SKY ISLANDS","color":"red"},{"text":" "},{"text":"|","color":"white"},{"text":" "},{"text":"Boosters Left:","color":"yellow"},{"text":" "},{"score":{"name":"*","objective":"boosts_game"},"color":"dark_green"},{"text":" \u00A77(x"},{"score":{"name":"*","objective":"booster_type"},"color":"gray"},{"text":"\u00A77)"}]

### JAPAN
execute as @a unless entity @s[scores={shop=1..}] if score map map matches 6 run title @s[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] actionbar ["",{"text":"Chosen Map:","color":"yellow"},{"text":" "},{"text":"平等院 (Byōdō-in)","color":"red"},{"text":" "},{"text":"|","color":"white"},{"text":" "},{"text":"Boosters Left:","color":"yellow"},{"text":" "},{"score":{"name":"*","objective":"boosts_game"},"color":"dark_green"},{"text":" \u00A77(x"},{"score":{"name":"*","objective":"booster_type"},"color":"gray"},{"text":"\u00A77)"}]

# Random Class Mechanics
scoreboard players add @a[tag=random_class] random_class 1
scoreboard players set @a[tag=random_class,scores={random_class=15..}] random_class 1

execute as @a[tag=random_class,tag=random_class_chosen] run team leave @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=1}] run team join class_scout @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=1}] run tellraw @s "§aThe Power of random let you play as §7Scout§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=2}] run team join class_taker @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=2}] run tellraw @s "§aThe Power of random let you play as §cTaker§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=3}] run team join class_mage @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=3}] run tellraw @s "§aThe Power of random let you play as §6Mage§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=4}] run team join class_ender @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=4}] run tellraw @s "§aThe Power of random let you play as §5Ender§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=5}] run team join class_healer @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=5}] run tellraw @s "§aThe Power of random let you play as §dHealer§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=6}] run team join class_archer @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=6}] run tellraw @s "§aThe Power of random let you play as §aArcher§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=7,lvl=20..}] run team join class_troll @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=7,lvl=20..}] run tellraw @s "§aThe Power of random let you play as §eTroll§a!"
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=7,lvl=..19}] run team join class_archer @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=7,lvl=..19}] run tellraw @s "§aThe Power of random let you play as §aArcher§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=8}] run team join class_shark @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=8}] run tellraw @s "§aThe Power of random let you play as §1Shark§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=9}] run team join class_alchemist @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=9}] run tellraw @s "§aThe Power of random let you play as §3Alchemist§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=10}] run team join class_bknight @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=10}] run tellraw @s "§aThe Power of random let you play as §9Blast Knight§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=11}] run team join class_zealot @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=11}] run tellraw @s "§aThe Power of random let you play as §bZealot§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=12,lvl=10..}] run team join class_creeper @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=12,lvl=10..}] run tellraw @s "§aThe Power of random let you play as §2Creeper§a!"
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=12,lvl=..9}] run team join class_zealot @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=12,lvl=..9}] run tellraw @s "§aThe Power of random let you play as §5Ender§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=13,lvl=20..}] run team join class_darkmage @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=13,lvl=20..}] run tellraw @s "§aThe Power of random let you play as §0Dark Mage§a!"
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=13,lvl=..19}] run team join class_ender @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=13,lvl=..19}] run tellraw @s "§aThe Power of random let you play as §0Dark Mage§a!"

execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=14,lvl=30..}] run team join class_tamer @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=14,lvl=30..}] run tellraw @s "§aThe Power of random let you play as §3Tamer§a!"
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=14,lvl=..29}] run team join class_mage @s
execute as @a[tag=random_class,tag=random_class_chosen,scores={random_class=14,lvl=..29}] run tellraw @s "§aThe Power of random let you play as §6Mage§a!"

execute as @a[tag=random_class,tag=random_class_chosen] run tag @s add class_choosen
execute as @a[tag=random_class,tag=random_class_chosen] run tag @s remove random_class_chosen


#
execute if entity @a[scores={win_word=1..}] run function map:winword
scoreboard players enable @a mycosmetics
execute if entity @a[scores={mycosmetics=1..}] run function map:mycosmetics 

execute unless entity @a[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] run execute as @e[x=-31,y=0,z=-31,dx=65,dz=65,dy=50,type=minecraft:armor_stand] at @s run data merge entity @s {CustomNameVisible:0b}
execute if entity @a[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] run execute as @e[x=-31,y=0,z=-31,dx=65,dz=65,dy=50,type=minecraft:armor_stand,tag=!lobby_gear] at @s run data merge entity @s {CustomNameVisible:1b}
execute if entity @a[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] run function map:classes_mech
execute if entity @a[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] run function map:parkour
scoreboard players set @a[x=-31,y=0,z=-31,dx=65,dz=65,dy=50] pearl_cd 0


#
# LVLS
#
execute as @a run execute store result score @s lvl run xp query @s levels

#
# Spectators
#
team leave @a[tag=spectator]
clear @a[tag=spectator]
effect give @a[tag=spectator] minecraft:invisibility 1 1 true
effect give @a[tag=spectator] minecraft:resistance 1 250 true
title @a[tag=spectator] actionbar "§aYou are currently Spectating"
gamemode spectator @a[tag=spectator,gamemode=!spectator]

#
# Players Test
#
execute store result score total players run execute if entity @a
execute store result score ingame players run execute if entity @a[tag=ingame]
execute store result score wclass players run execute if entity @a[tag=class_choosen]
execute store result score ender players run execute if entity @a[team=class_ender]

#
# Misc
#
execute as @a run execute unless entity @s[scores={boosts_game=0..}] run scoreboard players set @s boosts_game 0
execute as @a run execute unless entity @s[scores={coins=0..}] run scoreboard players set @s coins 0
kill @e[type=item,nbt={Item:{tag:{Tags:["shop_item"]}}}]
kill @e[nbt={Item:{tag:{Tags:[und]}}}]

scoreboard players enable @a stopmusic
execute if entity @a[scores={stopmusic=1..}] run stopsound @a[scores={stopmusic=1..}]
scoreboard players set @a[scores={stopmusic=1..}] stopmusic 0

scoreboard players set @a[scores={boosts_game=..0}] booster_type 0
tag @a[scores={boosts_game=..0}] remove coins_x3_boost
tag @a[scores={boosts_game=..0}] remove coins_x2_boost

recipe give @a *

#
# Timer
#
execute if score time game_time matches 1200 run tellraw @a[] "§9[Map] §a1 Minute Remaining!"
execute if score time game_time matches 1200 run execute as @a at @s run playsound minecraft:entity.arrow.hit_player master @a ~ ~ ~ 1 1.5
execute if score time game_time matches 600 run tellraw @a[] "§9[Map] §a30 Seconds Remaining!"
execute if score time game_time matches 600 run execute as @a at @s run playsound minecraft:entity.arrow.hit_player master @a ~ ~ ~ 1 1.5

scoreboard players remove time game_time 1
execute if score time game_time matches 1..6 run spawnpoint @a[tag=ingame] 0 15 0
execute if score time game_time matches 1..6 run tellraw @a[] "\u00A79[Map] \u00A7cDraw! Time is out!"
execute if score time game_time matches 1..6 run function map:reset


execute if score time game_time < time_limit game_time run scoreboard players set time game_time 0
bossbar set minecraft:game_time name ["",{"text":"Time Left:","color":"green"},{"text":" "},{"score":{"name":"time","objective":"game_time"},"color":"red"}]
execute if score time game_time <= time_limit game_time run bossbar set minecraft:game_time players

#
# Coins Limit
#

tellraw @a[scores={coins=5000001..}] "\u00A79[Map] \u00A7cYou have reached the coins limit! \u00A77(5,000,000)"
scoreboard players set @a[scores={coins=5000001..}] coins 5000000
scoreboard players set @a[scores={coins=..0}] coins 0

#
# Countdown Timer
#
execute if score time start_timer matches 100 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] times 10 20 10
execute if score time start_timer matches 1.. run scoreboard players remove time start_timer 1
execute if score time start_timer matches 100 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] title "\u00A745..."
execute if score time start_timer matches 100 run execute at @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:block.stone_button.click_on master @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1
execute if score time start_timer matches 80 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] title "\u00A7c4..."
execute if score time start_timer matches 80 run execute at @a run playsound minecraft:block.stone_button.click_on master @a ~ ~ ~ 5 1
execute if score time start_timer matches 60 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] title "\u00A763..."
execute if score time start_timer matches 60 run execute at @a run playsound minecraft:block.stone_button.click_on master @a ~ ~ ~ 5 1
execute if score time start_timer matches 40 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] title "\u00A7e2..."
execute if score time start_timer matches 40 run execute at @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:block.stone_button.click_on master @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1
execute if score time start_timer matches 20 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] title "\u00A721..."
execute if score time start_timer matches 20 run execute at @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:block.stone_button.click_on master @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1
execute if score time start_timer matches 1 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] title "\u00A74\u00A7lTHE FIGHT BEGINS"
execute if score time start_timer matches 1 run title @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] subtitle "\u00A7cPvP is Enabled"
execute if score time start_timer matches 1 run execute at @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:entity.ender_dragon.ambient master @a[tag=!sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1.5

# CHAT
execute if score time start_timer matches 100 run title @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] times 10 20 10
execute if score time start_timer matches 100 run tellraw @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] "§45.."
execute if score time start_timer matches 100 run execute at @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:block.stone_button.click_on master @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1
execute if score time start_timer matches 80 run tellraw @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] "§c4..."
execute if score time start_timer matches 80 run execute at @a run playsound minecraft:block.stone_button.click_on master @a ~ ~ ~ 5 1
execute if score time start_timer matches 60 run tellraw @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] "§63..."
execute if score time start_timer matches 60 run execute at @a run playsound minecraft:block.stone_button.click_on master @a ~ ~ ~ 5 1
execute if score time start_timer matches 40 run tellraw @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] "§e2..."
execute if score time start_timer matches 40 run execute at @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:block.stone_button.click_on master @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1
execute if score time start_timer matches 20 run tellraw @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] "§21..."
execute if score time start_timer matches 20 run execute at @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:block.stone_button.click_on master @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1
execute if score time start_timer matches 1 run tellraw @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] "§4§lTHE FIGHT BEGINS! §cPvP is Enabled"
execute if score time start_timer matches 1 run execute at @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] run playsound minecraft:entity.ender_dragon.ambient master @a[tag=sett_startmsg_chat,tag=!sett_startmsg_off] ~ ~ ~ 5 1.5
